PROGRAM READER_SiII

INTEGER :: i, n, k, l, u, toohigh=0, identical=0
CHARACTER :: trash
CHARACTER(len=16), DIMENSION(1000) :: config
CHARACTER(len=8), DIMENSION(1000) :: term
DOUBLE PRECISION, DIMENSION(1000) :: level, J, alpha, alpha_T0
character(len=15) :: temp
DOUBLE PRECISION, DIMENSION(1000) :: wl, A, Elow, Ehigh
DOUBLE PRECISION, DIMENSION(1000,1000) :: UPSILON, UPSILON_T
INTEGER :: J1, J2
DOUBLE PRECISION :: cutlevel, ionlimit
LOGICAL :: HIT

alpha = 0
aplha_T0 = 0
UPSILON = 0
UPSILON_T = 0

cutlevel = 0.99

ionlimit = 95751.87

! ....................................................

OPEN(10, file='caII_NIST.dat'); REWIND(10)

DO i = 1, 4
   READ(10,*) trash
END DO

ind = 0
DO 

   READ(10,'(A16)',END=100, advance='no') config(ind+1)

   ind = ind + 1

   temp = config(ind)

   PRINT *, temp

   IF (temp(1:1) .NE. ' ') THEN

      READ(10,'(A1,A8,A1,I3,A1,I2,A1,F12.2)',END=100) trash, term(ind), trash, J1, trash, J2, trash, level(ind)
 
      J(ind) = DBLE(J1)/DBLE(J2)
 
      PRINT *, term(ind), J(ind), level(ind)

   ELSE

      READ(10,'(A10,I3,A1,I2,A1,F12.2)',END=100) trash, J1, trash, J2, trash, level(ind)
 
      J(ind) = DBLE(J1)/DBLE(J2)
 
     PRINT *, term(ind), J(ind), level(ind)

      config(ind) = config(ind-1)
      term(ind) = term(ind-1)

   END IF

   IF (level(ind) > cutlevel*ionlimit) ind = ind - 1


END DO

100 continue

PRINT *, 'no levels:', ind

close(10)

OPEN(20, file='caII.dat_temp', STATUS='REPLACE')

WRITE(20,*) 'CA II  NIST DATA'
WRITE(20,*) 'n       E        g'

DO k = 1, ind

   WRITE(20,'(I5, F15.3, I7, A25, A4)') k, level(k), INT(2*J(k)+1), config(k), term(k)(1:4)

END DO



! ----------- LINE READING --------------------------------------

OPEN(30, file='caII_lines.dat');REWIND(30)

DO k = 1, 20
   READ(30,*) trash
END DO

n = 0
DO 

   READ(30,*,END=200) wl(n+1), trash, A(n+1), trash, trash, trash, Elow(n+1), trash, Ehigh(n+1)

   IF (n+1>2) THEN

      IF (Elow(n+1) .EQ. Elow(n) .AND. Ehigh(n+1) .EQ. Ehigh(n)) THEN
         !print *, 'apan', A(n+1), A(n)
         A(n) = maxval([A(n+1), A(n)])
        
         A(n+1) = 0
        
         WRITE(*,*) 'SAME WL!', A(n-1)
        
          print *, n+24+2+i
         
          identical = identical + 1
        
      ELSE

         IF (Elow(n+1) < cutlevel*ionlimit .AND. Ehigh(n+1) < cutlevel*ionlimit) THEN 

            n = n + 1
         
         ELSE

            toohigh = toohigh + 1

         END IF

      END IF

   ELSE

      IF (Elow(n+1) < cutlevel*ionlimit .AND. Ehigh(n+1) < cutlevel*ionlimit) THEN

         n = n + 1

      ELSE

        toohigh = toohigh + 1

      END IF

   END IF

END DO

200 continue

close(30)

print *, 'TOtal lines', n

print *, 'Too high', toohigh

print *, 'Identical', identical

print *, 'sum', n + toohigh + identical

! --------------- WRITE LINES ---------------------------------------

!UPSILON(2,1) = 15.9*0.33         ! Pradhan table
!UPSILON(3,1) = 15.9*0.67

open(10,file='caII_upsilon.dat',STATUS='OLD')

DO i = 1, 5

  read(10,*) trash

END DO

DO  

   read(10,*,END=33) trash, l, u, UPSILON(u,l) 

   print *, l, u, UPSILON(u,l)

END DO

33 close(10)

WRITE(20,*) 'Lines'
WRITE(20,*) 'i   j    WL      A'

print *, 'banan', Ehigh(1:3), Elow(1:3)

DO u = 2, ind
   DO l = 1, u-1
      
      HIT = .FALSE.

      DO k = 1, n   ! Go through all lines, see if any matches this transition

         IF ( (Ehigh(k) .EQ. level(u)) .AND. (Elow(k) .EQ. level(l) ) .AND. UPSILON(u,l) > 0) THEN

               WRITE(20,'(2I5, F20.2, ES12.2, ES10.2, I10)') u, l, wl(k), A(k), UPSILON(u,l), 3000

               HIT = .TRUE.

         ELSE IF ( (Ehigh(k) .EQ. level(u)) .AND. (Elow(k) .EQ. level(l)) ) THEN

                WRITE(20,'(2I5, F20.2, ES12.2, 2I10)') u, l, wl(k), A(k), 0, 0

                HIT = .TRUE.

         END IF

      END DO

      IF (UPSILON(u,l) > 0 .AND. (HIT .EQV. .FALSE.)) THEN

          WRITE(20,'(2I5, F20.2, ES12.2, ES10.2, I10)') u, l, 0, 0, UPSILON(u,l), 3000

          print *, u, l, UPSILON(u,l)

      END IF

   END DO

END DO


close(20)

END
