PROGRAM OI_FIXER
IMPLICIT NONE

CHARACTER(len=70) :: string
INTEGER :: n, i, j
DOUBLE PRECISION, DIMENSION(13) :: E, g
DOUBLE PRECISION, DIMENSION(13,13) :: A, omega5000, omega10000
REAL :: x
CHARACTER :: trash
CHARACTER(len=3) :: label1
CHARACTER(len=5) :: label2
REAL :: alpha, T, beta

! ------------------------------------------

OPEN(10,file='oI.dat', STATUS='OLD')
OPEN(20,file='oI_new.dat', STATUS='REPLACE')


DO i = 1, 2
   READ(10,'(A70)') string
   WRITE(20,'(A70)') string
END DO

READ(10,*) trash

DO i = 1,13
   READ(10,*) n, E(i), g(i), label1, label2, alpha, T, beta
   WRITE(20,'(I2, F9.1, I5, A7, A7, ES10.2, 2F10.2)') n, E(i), INT(g(i)), label1, label2, alpha, T, beta
END DO

DO i = 1,2
   read(10,*) string
END DO


WRITE(20,*) 'Lines'
WRITE(20,*) '  j   i        lambda     A         Omega5000        Omega10000'

DO WHILE (1 .eq. 1)

   READ(10,*,END=100) i, j, A(j,i), omega5000(j,i), omega10000(j,i)
 
END DO

100 close(10)

DO j = 2, 13
   DO i = 1, (j-1)

    WRITE(20,'(2I5, F15.2, ES10.2, 2ES12.2)') j, i, 1.0/(E(j)-E(i))*1e8, A(j,i), omega5000(j,i), omega10000(j,i)

   END DO
END DO

close(10)

END PROGRAM
