PROGRAM READER_OI
IMPLICIT NONE

INTEGER :: i, n, k, l, u
CHARACTER :: trash
CHARACTER(len=23), DIMENSION(1000) :: config
CHARACTER(len=8), DIMENSION(1000) :: term
CHARACTER(len=4) :: Jtemp
CHARACTER(len=8) :: termtemp
CHARACTER(len=23) :: configtemp
DOUBLE PRECISION, DIMENSION(1000) :: level, J, alpha, alpha_T0, recbeta
DOUBLE PRECISION, DIMENSION(1000) :: wl, A, Elow, Ehigh
DOUBLE PRECISION, DIMENSION(1000,1000) :: UPSILON, BETA, UPSILON_T

alpha = 0
alpha_T0 = 0
recbeta = 0
level = 0
J = 0
wl = 0
A = 0
Elow = 0
Ehigh = 0
UPSILON = 0
BETA = 0
UPSILON_T = 0

! ....................................................

OPEN(10, file='oI_NIST_levels.dat',STATUS='OLD'); REWIND(10)

DO i = 1, 3
   READ(10,*) trash
END DO

i = 0
DO WHILE (1==1)

   READ(10,'(A23,A1,A8,A1)',END=100, ADVANCE='NO') configtemp, trash, termtemp, trash

   IF (termtemp .EQ. '         ') THEN

      i = i + 1
      READ(10,*) J(i), trash, level(i), trash
      term(i) = term(i-1)
      config(i) = ' '

   ELSE

       i = i + 1
       READ(10,*) J(i), trash, level(i), trash
       term(i) = termtemp
       config(i) = configtemp

   END IF

   PRINT *, level(i)
      
END DO

100 continue

PRINT *, 'Number of levels:', i

close(10)

OPEN(10, file='recrates_specific_oI.dat',STATUS='OLD')

DO WHILE (1 .EQ. 1)
   
   READ(10,*,END=300) k, trash, trash, alpha(k), alpha_T0(k), recbeta(k)

END DO

300 close(10)

OPEN(20, file='oI.dat', STATUS='REPLACE')

WRITE(20,*) 'O I L&L from NIST. Rec: ? CS: ?.'
WRITE(20,*) 'n       E        g'

DO k = 1, i

   WRITE(20,'(I5, F15.3, I7, ES15.2, I10, ES10.2, A25, A8)') k, level(k), INT(2*J(k)+1), alpha(k), INT(alpha_T0(k)), recbeta(k), config(k), term(k)

END DO

! ----------- LINE READING --------------------------------------

OPEN(30, file='oI_NIST_lines.dat');REWIND(30)

DO k = 1, 5
   READ(30,*) trash
END DO

n = 0
DO 

   READ(30,*,END=200) wl(n+1), trash, A(n+1), trash, trash, trash, Elow(n+1), trash, Ehigh(n+1)
   
   IF (n>0 .AND. (Elow(n+1) .EQ. Elow(n)) .AND. (Ehigh(n+1) .EQ. Ehigh (n))) THEN
 
         WRITE(*,*) 'Same line!', n
    
         IF (A(n+1) > A(n)) THEN

            A(n) = A(n+1)

            PRINT *, 'Replaced'

         ELSE

            PRINT *, 'Did not replace'

         END IF
      
   ELSE

      n = n + 1

   END IF

END DO

200 continue

close(30)

OPEN(40,file='oI_collisions.dat',STATUS='OLD');REWIND(40)  ! TEMP include these

DO k = 1, 2
   READ(40,*) trash
END DO

DO WHILE (1==1)
   
   READ(40,*,END=500) u, l, trash, trash, upsilon(u,l), beta(u,l), upsilon_T(u,l)

END DO

500 close(40)

! --------------- WRITE LINES ---------------------------------------

WRITE(20,*) 'Lines'
WRITE(20,*) 'i   j                 WL        A          UPSILON          T            BETA'

DO u = 2, i
   DO l = 1, (u-1)

      DO k = 1, n

         IF ( (Ehigh(k) .EQ. level(u)) .AND. (Elow(k) .EQ. level(l) ))THEN

            WRITE(20,'(2I5, F20.2, ES12.2, ES10.2, I10, ES10.2)') u, l, wl(k), A(k), UPSILON(u,l), INT(UPSILON_T(u,l)), BETA(u,l)

            GOTO 50

         END IF

      END DO

      IF (upsilon(u,l) > 0) THEN

        WRITE(20,'(2I5, F20.2, ES12.2, ES10.2, I10, ES10.2)') u, l, 0., 0., UPSILON(u,l), INT(UPSILON_T(u,l)), BETA(u,l)

      end if

   50 continue

   END DO

END DO


close(20)

END
