PROGRAM READER
IMPLICIT NONE

INTEGER :: i, n, k, l, u, Jup, Jner 
CHARACTER :: trash
CHARACTER(len=21), DIMENSION(50) :: config
CHARACTER(len=10), DIMENSION(50) :: term
CHARACTER(len=4) :: Jtemp
CHARACTER(len=9) :: termtemp
CHARACTER(len=21) :: configtemp
DOUBLE PRECISION, DIMENSION(50) :: level, J, alpha, alpha_T0
DOUBLE PRECISION, DIMENSION(1000) :: wl, A, Elow, Ehigh
DOUBLE PRECISION, DIMENSION(100,100) :: UPSILON, UPSILON_T



! ....................................................

OPEN(10, file='oII_NIST.dat'); REWIND(10)

DO i = 1, 3
   READ(10,*) trash
END DO

i = 0
DO WHILE (1==1)

   READ(10,'(A16,A1,A8,A2,I1,A1,I1,A4,A2)',END=100, ADVANCE='NO') configtemp, trash, termtemp, trash, Jup, trash, Jner, trash 

   PRINT *, Jup, Jner


   IF (termtemp .EQ. '        ') THEN

      i = i + 1
      READ(10,*) level(i)
      term(i) = term(i-1)
      config(i) = ' '
      J(i) = DBLE(Jup)/DBLE(Jner)

   ELSE

       i = i + 1
       READ(10,*) level(i)
       term(i) = termtemp
       config(i) = configtemp
       J(i) = DBLE(Jup)/DBLE(Jner)

   END IF

      
END DO

100 continue

PRINT *, 'Number of levels:', i

close(10)

OPEN(20, file='oII.dat', STATUS='REPLACE')

WRITE(20,*) 'O II L&L from NIST. Coll. str:Pradhan online.'
WRITE(20,*) 'n       E        g'

DO k = 1, i

   WRITE(20,'(I5, F15.3, I7, A25, A10)') k, level(k), INT(2*J(k)+1), config(k), term(k)

END DO

! ----------- LINE READING --------------------------------------

OPEN(30, file='oII_lines.dat');REWIND(30)

DO k = 1, 5
   READ(30,*) trash
END DO

n = 0
DO WHILE (1==1)

   READ(30,*,END=200) wl(n+1), trash, A(n+1), trash, trash, trash, Elow(n+1), trash, Ehigh(n+1)
   
   IF (n>0) THEN
      IF (wl(n+1) .EQ. wl(n)) THEN
         WRITE(*,*) 'Same line!', n
         STOP 1
      END IF
   END IF

   n = n + 1

END DO

200 continue

close(30)

OPEN(40,file='oII_collstrengths.dat');REWIND(40)


DO k = 1, 10
   
   READ(40,*) u, l, upsilon(u,l), upsilon_T(u,l)

END DO

close(40)

! --------------- WRITE LINES ---------------------------------------

WRITE(20,*) 'Lines'
WRITE(20,*) 'i   j    WL      A'

DO u = 2, i
   DO l = 1, (u-1)

      DO k = 1, n

         IF ( (Ehigh(k) .EQ. level(u)) .AND. (Elow(k) .EQ. level(l) ) .AND. ((A(k) > 0) .OR. (UPSILON(u,l) > 0)))THEN

               WRITE(20,'(2I5, F20.2, ES12.2, F10.2, I10)') u, l, wl(k), A(k), UPSILON(u,l), INT(UPSILON_T(u,l))

         END IF

      END DO

   END DO

END DO


close(20)

END
