PROGRAM READER
IMPLICIT NONE

INTEGER :: i, n, k, l, u
CHARACTER :: trash, trash2
CHARACTER(len=21), DIMENSION(100) :: config
CHARACTER(len=10), DIMENSION(100) :: term
CHARACTER(len=4) :: Jtemp
CHARACTER(len=9) :: termtemp
CHARACTER(len=21) :: configtemp
DOUBLE PRECISION, DIMENSION(100) :: level, J, alpha, alpha_T0
DOUBLE PRECISION, DIMENSION(1000) :: wl, A, Elow, Ehigh
DOUBLE PRECISION, DIMENSION(100,100) :: UPSILON, UPSILON_T
INTEGER :: J1, J2


! ....................................................

OPEN(10, file='nI_levels.dat'); REWIND(10)

DO i = 1, 3
   READ(10,*) trash
END DO

i = 0
DO WHILE (1==1)

   READ(10,'(A19,A1,A10,A1,I3,A1,I2,A1)',END=100, ADVANCE='NO') configtemp, trash, termtemp, trash, J2, trash2, J1, trash

   IF (configtemp(1:1) .EQ. ' ' .AND. trash2 .EQ. ' ') THEN

      READ(10,*) trash

   ELSE IF (configtemp(1:1) .EQ. ' ') THEN

      i = i + 1
      J(i) = DBLE(J2)/DBLE(J1)
      READ(10,*) level(i)
      term(i) = term(i-1)
      config(i) = config(i-1)

   ELSE

       i = i + 1
       READ(10,*) level(i)

       J(i) = DBLE(J2)/DBLE(J1)
       term(i) = termtemp
       config(i) = configtemp

   END IF
      
END DO

100 continue

PRINT *, 'Number of levels:', i

close(10)

OPEN(20, file='nI.dat', STATUS='REPLACE')

WRITE(20,*) 'N I L&L from NIST.'
WRITE(20,*) 'n       E        g'

DO k = 1, i

   WRITE(20,'(I5, F15.3, I7, ES15.2, I10, A25, A10)') k, level(k), INT(2*J(k)+1), alpha(k), INT(alpha_T0(k)), config(k), term(k)

END DO

! ----------- LINE READING --------------------------------------

OPEN(30, file='nI_nist.dat');REWIND(30)

DO k = 1, 5
   READ(30,*) trash
END DO

n = 0
DO WHILE (1==1)

   IF (MOD(n+1,6) .NE. 0) THEN

      PRINT *, n+1

      READ(30,*,END=200) wl(n+1), trash, A(n+1), trash, trash, trash, Elow(n+1), trash, Ehigh(n+1)
   
      IF (n>0) THEN
         IF (wl(n+1) .EQ. wl(n)) THEN
            WRITE(*,*) 'Same line!', n
            STOP 1
         END IF
      END IF

   ELSE
      PRINT *, 'Off',n+1

      READ(30,*,END=200) trash

   END IF

   n = n + 1

END DO

200 continue

close(30)



! --------------- WRITE LINES ---------------------------------------

WRITE(20,*) 'Lines'
WRITE(20,*) 'i   j    WL      A'

DO u = 2, i
   DO l = 1, (u-1)

      DO k = 1, n

         IF ( (Ehigh(k) .EQ. level(u)) .AND. (Elow(k) .EQ. level(l) ) )THEN

               WRITE(20,'(2I5, F20.2, ES12.2, F10.2, I10)') u, l, wl(k), A(k), UPSILON(u,l), INT(UPSILON_T(u,l))

         END IF

      END DO

   END DO

END DO


close(20)

END
