import sys
import pandas as pd
import sys
sys.path.append('scripts')
from func_db2fort import * 

# =============================================================================
# This code takes the data base in human readable form, and makes a file that
# that is read in the SUMO subroutine SUIB. This table is used to the define
# the chemical reactions used in the code. 
# 
# The program is executed from the command line as:
# >>> python db2fort_iput.py <DATA_BASE_NAME>
# where the <DATA_BASE_NAME> is changed to the relevant name.
# =============================================================================
#


# arguments passed from the command line
input_arg = list([s.split(',')[0] for s in sys.argv])


# using the csv_write function from _func_db2fort.py function to convert the data
# base to suib input files

suib_input_writer(input_arg[1])





