PROGRAM SOLTRANS
IMPLICIT NONE

INTEGER, DIMENSION(100) :: A
CHARACTER(len=2), DIMENSION(100) :: name
REAL, DIMENSION(100) :: mass, x, ndens, nfrac, mfrac

INTEGER :: i, n
CHARACTER :: trash
REAL :: Amean, Ntot, HoverHe, Zfactor, factor

INTEGER, DIMENSION(19) :: vec
! --------------------------------------------------

OPEN(10,file='solar.dat',STATUS='OLD')

READ(10,*) trash
READ(10,*) trash


n = 0
DO WHILE (1 .EQ. 1)
   
   READ(10,*,END=200) A(n+1), name(n+1), mass(n+1), x(n+1)

   n = n + 1

END DO

200 close(10)

DO i = 1, n

   ndens(i) = 10**(x(i)-12.)

END DO

!ndens(6) = ndens(1)*3.2E-5
!ndens(7) = ndens(6)*5
!ndens(8) = ndens(6)*4

WRITE(*,*) 'H/He ?'
READ(5,*) HoverHe

IF (HOverHe .NE. 0) THEN

  ndens(2) = ndens(1)/HoverHe

END IF

!WRITE(*,*) 'Factor for Na, Mg, Ar and Ca?'
!READ(5,*) factor

!ndens(11) = factor*ndens(11)
!ndens(12) = factor*ndens(12)
!ndens(18) = factor*ndens(18)
!ndens(20) = factor*ndens(20)

!WRITE(*,*) 'Z/Z(solar)?'
!READ(5,*) Zfactor

!DO i = 26, 26 

!   ndens(i) = Zfactor*ndens(i)

!END DO

ntot = sum(ndens(1:n))

nfrac = ndens/ntot

!ntot = SUM(nfrac(6:8))

!nfrac(6) = ntot*1./9.

!nfrac(7) = ntot*5./9.

!nfrac(8) = ntot*4./9.

Amean = DOT_PRODUCT(mass, nfrac)

PRINT *, Amean


OPEN(20,file='solar_long.dat',STATUS='REPLACE')

mfrac = nfrac*mass/Amean

DO i = 1, n

   WRITE(20,*) A(i), name(i), mass(i), x(i), nfrac(i), mfrac(i) 
   
END DO

vec = (/1,2,6,7,8,10,11,12,14,16,18,20,26,27,28,22,13,24,25/)

DO i = 1, 19

   WRITE(20,'(I5, A10, ES10.2)') i, name(vec(i)), mfrac(vec(i))

END DO






close(20)

END
