DOUBLE PRECISION FUNCTION BETA_S_FUNC(tau)
IMPLICIT NONE

DOUBLE PRECISION, INTENT(IN) :: tau

IF (abs(tau) .GT. 1E-4 .AND. tau > -10) THEN           ! DO NOT REMOVE ABS negative optical depths give beta=1

   beta_s_func = (1.-EXP(-tau))/tau

ELSEIF (tau <= -10) THEN

   beta_s_func = 2202. ! 2202. ! TEMP
	 
ELSE
		     
   beta_s_func = 1.		! If optical depth very small, set escape prob to 1 to avoid numerical difficulties.	
   
END IF

RETURN

END FUNCTION BETA_S_FUNC
