subroutine checkerrors(N, cal, ans, tol, ERROR)
use M1
implicit none
! -------------------------------------------------------
integer, INTENT(IN) :: N
double precision, dimension(N), INTENT(IN) :: cal, ans
double precision, INTENT(IN) :: tol
logical, INTENT(OUT) :: ERROR

double precision, dimension(N) :: ratio, rel_error
INTEGER :: i
! ----------------------------------------------------------

rel_error = 1

! ----------------------------------------------------------

PRINT *, 'Cal and Ans:'

DO i = 1, N

   WRITE(*,'(I5, 2ES10.2)') i, cal(i), ans(i)

END DO


DO i = 1, N

   IF (ans(i) == 0) THEN

      IF (cal(i) == 0) THEN

         rel_error(i) = 0

      ELSE

         rel_error(i) = 1

      END IF
   
   ELSE

      rel_error(i) = abs(cal(i) - ans(i))/abs(ans(i))

   END IF

END DO

write(*,*) 'Maximum relative error: ', maxval(rel_error)

if ( maxval(rel_error) .GT. tol) then
        ERROR=.TRUE.
        WRITE(*,*) 'ERROR'
else
        ERROR=.FALSE.
end if

return
end subroutine checkerrors
