      subroutine co_photodiss(ireadph,denco,tday,wl,tau)

c reads photodiss. osc. strengths and calculates the optical depth in the
c sobolev approx. Photo data from Visser et al 2009

      implicit real*8(a-h,o-z)

      real*8 atot(50),fvlvu(50),nvlvu(50),eta(50)
      character*8 char
      integer iul(50)
      integer vp
      real*8 tau(40),wl(40)

      data h/6.6256e-27/,c/2.997925e10/

      save fvlvu,atot,eta,nvlvu

      pi=3.14159d0

      pisqrt=dsqrt(pi)

      if(ireadph.eq.1) then
 
         open(12,file='DATA/molecules/CO_photo_diss_visser_vd_blac09.dat')

c read dissociation data from van Dishoeck and Black

         read(12,*)char

         do i = 1, 37

            read(12,*,end=11)no,ilv,ils,ill,iuv,ius,iul(i),wlq,nvlvu(i),
     &           vp,fvlvu(i),atot(i),eta(i),bp,dp,ome,omxe

         enddo

 11      continue

         close (12)

      endif

      pie2_over_mc = 0.0265

      do i = 1, 37

         wl(i) = 1./nvlvu(i)

c optical depth for band

         drdv = tday*8.64e4

         tau(i)= pie2_over_mc * fvlvu(i) * wl(i) * denco * drdv

      enddo

      wl = wl*1E8 ! Convert to 

      return
      end


