SUBROUTINE FINDBIN2(N, array, x, bin)
IMPLICIT NONE

INTEGER, INTENT(IN) :: N
DOUBLE PRECISION, DIMENSION(N), INTENT(IN) :: array
DOUBLE PRECISION, INTENT(IN) :: x
INTEGER, INTENT(OUT) :: bin

INTEGER :: block

IF (x >= array(N)) THEN  
  bin = 0
  RETURN
ELSEIF (x < array(1)) THEN
  bin = 0
  RETURN
END IF

bin = N/2

block = bin/2

DO


  IF (x >= array(bin+1)) THEN

     !bin = bin/2
 
     bin = bin + block

  ELSEIF (x < array(bin)) THEN

    bin = bin - block
    !bin = bin + (N-bin)/2

  ELSE

     EXIT

  END IF

  block = block/2

  IF (block == 0) block = 1

END DO

END


SUBROUTINE FINDBIN3(inx, N, array, x, bin)
IMPLICIT NONE

INTEGER, INTENT(IN) :: inx,N
REAL, DIMENSION(:,:), INTENT(IN) :: array
DOUBLE PRECISION, INTENT(IN) :: x
INTEGER, INTENT(OUT) :: bin

INTEGER :: block

IF (x >= dble(array(inx,N))) THEN  
  bin = 0
  RETURN
ELSEIF (x < dble(array(inx,1))) THEN
  bin = 0
  RETURN
END IF

bin = N/2

block = bin/2

DO


  IF (x >= dble(array(inx,bin+1))) THEN

     !bin = bin/2
 
     bin = bin + block

  ELSEIF (x < dble(array(inx,bin))) THEN

    bin = bin - block
    !bin = bin + (N-bin)/2

  ELSE

     EXIT

  END IF

  block = block/2

  IF (block == 0) block = 1

END DO

END 
