PROGRAM TEQSCOLLECTOR
USE M1
USE FILES, ONLY : file_runparameters
IMPLICIT NONE

INTEGER :: i
REAL, DIMENSION(:), ALLOCATABLE :: t
CHARACTER :: trash
LOGICAL :: EXISTS

IF (COMMAND_ARGUMENT_COUNT() >= 1) THEN
  CALL GET_COMMAND_ARGUMENT(1, file_runparameters) ! Run parameters file name (optional)
END IF

open(10,file=file_runparameters,STATUS='OLD')

do i = 1, 4; read(10,*) trash; end do

read(10,*) trash, Nr

close(10)

ALLOCATE(t(Nr)); t=0

!CHARACTER(len=2), DIMENSION(15) :: R_index_str=['01','02','03','04','05','06','07','08','09','10','11','12','13','14','15']

DO i = 1, Nr

  OPEN(10,file='out/plts/teqs.dat'//R_index_str(i),STATUS='OLD')

  READ(10,*) t(i)

  close(10)

END DO



INQUIRE(file='out/plts/teqslong.dat',Exist=EXISTS)

IF (EXISTS) THEN

   OPEN(10,file='out/plts/teqslong.dat',STATUS='OLD',POSITION='APPEND')

ELSE

   OPEN(10,file='out/plts/teqslong.dat',STATUS='NEW')

END IF

WRITE(10,'(10000F10.2)') t

close(10)

open(10,file='out/plts/teqsordered.dat',STATUS='REPLACE')

DO i = 1, Nr

  write(10,*) i, INT(t(i))

END DO

close(10)
DEALLOCATE(t)

END
