program reader
IMPLICIT NONE

CHARACTER(len=26) :: name
DOUBLE PRECISION, DIMENSION(1000) :: WL, A, lower, upper, level
INTEGER, DIMENSION(1000) :: J
CHARACTER(len=1) :: trash
CHARACTER(len=10) :: trashbin
INTEGER :: i, k, u, l


OPEN(10, file='caIraw2.dat')

level = 0
WL = 0
A = 0
lower = 0
upper = 0
J = 0

i = 1
DO WHILE (1 == 1)

   READ(10,*,ERR = 50, END=100) J(i), trash, level(i)
   PRINT *, i, J(i), trash, level(i)
   i = i + 1
   50 continue

END DO

100 continue


CLOSE(10)

OPEN(20, file='caI.dat', STATUS='REPLACE')


WRITE(20,*) 'Ca I'
WRITE(20,*) 'n      E [cm-1]        g'
DO k = 1, i-1

   WRITE(20,*) k, level(k), 2*J(k)+1

END DO

WRITE(20,*) 'Transitions'
WRITE(20,*) 'n2 n2     WL[]    A '



OPEN(30, file='caIlinesraw2.dat')


i = 1
DO WHILE (1 == 1)
   READ(30,*, END=200) WL(i), trash, trash, trash, A(i), trash, trash, trash, lower(i), trash, upper(i)
   WRITE (*,33), WL(i), A(i), lower(i), upper(i)
   33 FORMAT (F20.8, ES12.4, 2F20.4)
   i = i + 1
END DO

200 continue

close(30)

PRINT *, 'Nlines:', i

DO u = 2, 86
   DO l = 1, (u-1)

      PRINT *, u, l, level(u), level(l)

      DO k = 1, i

         IF ( (upper(k) .EQ. level(u)) .AND. (lower(k) .EQ. level(l)) .AND. (A(k) > 0) ) THEN

            PRINT *, 'Line found!'

            WRITE(20,21) u, l, WL(k), A(k)
            21 FORMAT (2I5, F10.2, ES12.4)

         END IF

      END DO
   END DO
END DO



close(20)            

END
