program reader_coI
IMPLICIT NONE

CHARACTER(len=26) :: name
DOUBLE PRECISION, DIMENSION(1000) :: WL, A, lower, upper, level, alpha, alpha_T0
DOUBLE PRECISION, DIMENSION(1000) :: J
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: UPSILON
CHARACTER(len=1) :: trash
CHARACTER(len=30) :: temp, trashbin
CHARACTER(len=10), DIMENSION(:), ALLOCATABLE :: term
CHARACTER(len=25), DIMENSION(:), ALLOCATABLE :: config
CHARACTER(len=6) :: Jstring
INTEGER :: i, k, u, l, Nlevels, Nlines, foundcounter
LOGICAL :: FOUND


Nlevels = 169

ALLOCATE(term(Nlevels))
ALLOCATE(config(Nlevels))
ALLOCATE(UPSILON(Nlevels*(Nlevels-1)/2,Nlevels*(Nlevels-1)/2)); UPSILON = 0

OPEN(10, file='coI_levels.dat')
!OPEN(11, file='coI_recombdata.dat')

level = 0
WL = 0
A = 0
lower = 0
upper = 0
J = 0

i = 1

DO i = 1,3
READ(10,*) trash
!READ(11,*) trash
END DO

i = 1
DO WHILE (1 == 1)

   READ(10,'(A25)',ERR = 50, END=100, ADVANCE='no') config(i)

   PRINT *, 'Config:', config(i)

   temp = config(i)

   IF (temp(1:1) .NE. ' ') THEN

      READ(10,'(A1, A8, A1, A6, A1, F13.2,A5)',ERR = 50, END=100) trash, term(i), trash, Jstring, trash, level(i), trashbin

      PRINT *,'ICHAR', ICHAR(Jstring(3:3)), IACHAR(Jstring(3:3))
      J(i) = REAL(ICHAR(Jstring(3:3))-ICHAR('0'))/REAL(ICHAR(Jstring(5:5))-ICHAR('0'))

 !     READ(11,*) trash, trash, trash, trash, trash, trash, trash, trash, alpha(i), alpha_T0(i)


   ELSE

      PRINT *, 'Sublevel!'

      READ(10,'(A10,A6,A1,F13.2)',ERR = 50, END=100) trash, Jstring, trash, level(i)
      J(i) = REAL(ICHAR(Jstring(3:3))-ICHAR('0'))/REAL(ICHAR(Jstring(5:5))-ICHAR('0'))
      
  !    READ(11,*) trash, trash, trash, trash, trash, trash, alpha(i), alpha_T0(i)
 

      config(i) = config(i-1)
      term(i) = term(i-1)
      PRINT *, 'J', J(i)

   END IF


   PRINT *, 'i, E, J, config, term:', i, level(i), J(i), config(i), term(i)
   i = i + 1
   50 continue

END DO

100 continue


CLOSE(10)
!close(11)

OPEN(20, file='coI.dat', STATUS='REPLACE')


WRITE(20,*) 'Co I'
WRITE(20,*) 'n      E [cm-1]        g'
DO k = 1, i-1

   WRITE(20,'(I5, F15.3, I7, A30, A15)') k, level(k), INT(2*J(k)+1), config(k), term(k)

END DO

WRITE(20,*) 'Transitions'
WRITE(20,*) '   n2   n1            WL[]       A     UPSILON     T '


OPEN(30, file='coI_lines.dat')

DO i = 1,5
   READ(30,*) trash
END DO


i = 1
DO WHILE (1 == 1)
   READ(30,*, END=200) WL(i), trash, A(i), trash, trash, trash, lower(i), trash, upper(i)
   WRITE (*,33), WL(i), A(i), lower(i), upper(i)
   33 FORMAT (F20.8, ES12.4, 2F20.4)
   i = i + 1
END DO

200 continue

close(30)

PRINT *, 'max upper', maxval(upper)

Nlines = i

PRINT *, 'Nlines:', Nlines

! ------- COLLISION STRENGTHS  --------------------

!OPEN(40, file='coI_upsilon.dat')

!DO i = 1, 5
!   READ(40,*) trash
!END DO

!DO k = 1, 45
!   READ(40,*) trash, l, u, UPSILON(u,l)
!   PRINT *, 'UPSILON',u,l,UPSILON(u,l)
!END DO

!CLOSE(40)

! ----------- WRITE LINES -----------------------

foundcounter = 0
DO u = 2, Nlevels
   DO l = 1, (u-1)

      PRINT *, u, l, level(u), level(l)

      FOUND = .FALSE.

      DO k = 1, Nlines

         IF ((upper(k) .EQ. level(u)) .AND. (lower(k) .EQ. level(l)) ) THEN

            PRINT *, 'Line found!'
            foundcounter = foundcounter + 1

            FOUND = .TRUE.
            EXIT

         END IF

      END DO

      IF (FOUND) THEN 

            WRITE(20,21) u, l, WL(k), A(k)
            21 FORMAT (2I5, F20.2, ES12.2)

      ELSE

            continue
            !WRITE(20,'(2I5, F20.0, F12.0)') u, l, 0, 0
         
      END IF
      

   END DO
END DO



close(20)            

PRINT *, 'Found', foundcounter, 'out of ',Nlines, 'lines'

END
