PROGRAM CREATENEW

IMPLICIT NONE

CHARACTER(len=1000):: line1, line2, line3, line4
INTEGER :: i, n, j, npoints, ind, ii
REAL, DIMENSION(578) :: energy
INTEGER, DIMENSION(578) :: g
CHARACTER(len=1000), DIMENSION(578) :: text
DOUBLE PRECISION, DIMENSION(578,578) :: lambda, A, omega, omega_zhang1995, omega_ramsbottom2007, omega_bautista1996few, omega_tipbasefew
INTEGER, DIMENSION(578,578) :: fuhr
INTEGER, DIMENSION(95) :: map
DOUBLE PRECISION :: val
CHARACTER :: trash
DOUBLE PRECISION, DIMENSIOn(100) :: logT, valvec

open(10,file='feII.dat')

read(10,'(A)') line1
  
read(10,'(A)') line2

DO i = 1, 578

   read(10,'(A)') text(i)

END DO

read(10,'(A)') line3

read(10,'(A)') line4

DO

  read(10,*,END=300) j, i, lambda(j,i), A(j,i), omega(j,i), fuhr(j,i)

END DO

300 close(10)

open(10,file='feII_collstrengths_zhang1995.dat',STATUS='OLD',ACTION='READ') ! -----------------------

read(10,*) trash

read(10,*) trash

DO i = 1, 95

   read(10,*) n, map(n)  ! level n in zhang maps to level map in the model atom

END DO

read(10,*) trash

DO

  read(10,*,END=444) i, j, trash, trash, val


  if (i > 95 .or. j > 95) cycle

  if (map(i) > 0 .and. map(j) > 0) omega_zhang1995(map(j),map(i)) = val

END DO

444 close(10)

open(10,file='feII_finestructurecollisions_ramsbottom2007.dat',STATUS='OLD',ACTION='READ') ! ------------------------

DO i = 1, 17

  read(10,*) trash

END DO

DO

  read(10,*,END=555) i, j, trash, trash, trash, trash, trash, trash, trash, trash, trash, trash, trash, trash, val

  omega_ramsbottom2007(j,i)  = val

END DO

555 close(10)

open(10,file='feII_collstrengths_bautista1996.dat',STATUS='OLD')  ! A few values from Bautists1996 I took out by hand, outdated -----------------------

read(10,*) trash

DO

  read(10,*,END=666) j, i, omega_bautista1996few(j,i)

END DO

666 close(10)

open(10,file='feII_collstrengths_tipbase.dat',STATUS='OLD') ! Collision strengths for all transitions levels 1-80, data is Zhang & Pradhan 1995 + Bautists 1996 --------------

DO i = 1, 3
  read(10,*) trash
end do

DO

  read(10,*,END=777) trash, trash, trash, j, i, npoints


  DO ii = 1, npoints

     read(10,*) logT(ii), valvec(ii)

  end do

  call findbin2(npoints, logT(1:npoints), DBLE(log10(5100.)), ind)  ! There is a temperature at ~5010 A

  omega_tipbasefew(j,i) = valvec(ind)

end do

777 close(10)

where (omega_zhang1995 > 0)
  omega = omega_zhang1995
end where

WHERE (omega_tipbasefew > 0)
  omega = omega_tipbasefew  ! Replace all values by Zhang and Pradhan 1995 + bautista1996 (5000 K)
END WHERE

omega(1:16,1:16) = omega_ramsbottom2007(1:16,1:16)  ! Replace all 1-16 transitions with ramsbottom 2007 values (5000 K)

open(10,file='feII.dat', STATUS='REPLACE')

write(10,'(A)') TRIM(line1)

write(10,'(A)') TRIM(line2)

DO i = 1, 578

  write(10,'(A)') TRIM(text(i))

END DO

write(10,'(A)') TRIM(line3)

write(10,'(A)') TRIM(line4)

DO j = 2, 578

  DO i = 1, (j-1)

      IF (A(j,i) > 0 .or. omega(j,i) > 0) THEN

         write(10,'(2I6, F14.2, ES12.2, 1ES12.2, I6)') j, i, lambda(j,i), A(j,i), omega(j,i), fuhr(j,i)
 
      END IF

  END DO

END DO

close(10)

END
