SUBROUTINE FEII_COLLISIONRATES(T, UPSILON)
IMPLICIT NONE

DOUBLE PRECISION, INTENT(IN) :: T
DOUBLE PRECISION, DIMENSION(16,16), INTENT(OUT) :: UPSILON

INTEGER i, j, ind, bin
CHARACTER :: trash
DOUBLE PRECISION, DIMENSION(27) :: Tvec, upsilonvec
DOUBLE PRECISION, DIMENSION(26), SAVE :: ALPHA, C

! ------------------------------------------------------

UPSILON = 0

! ------------------------------------------------------

OPEN(10,file='/home/andersj/atoms/FeII/feII_finestructurecollisions.dat'); REWIND(10)

DO i = 1, 16
   READ(10,*) trash
END DO

READ(10,*) Tvec

DO WHILE (1 .EQ. 1)

   READ(10,*,END=100) i, j, upsilonvec

   DO i = 1, 26

      alpha(i) = LOG(upsilonvec(i)/upsilonvec(i+1))/LOG(Tvec(i)/Tvec(i+1))
      C(i) = upsilonvec(i)/Tvec(i)**alpha(i)

   END DO

   IF (T < Tvec(1)) THEN

      UPSILON(j,i) = C(1)*T**alpha(1)

   ELSE IF (T > Tvec(length(Tvec))) THEN

      UPSILON(j,i) = C(26)*T**alpha(26)

   ELSE

      bin = 1
      DO WHILE (T<Tvec(bin+1))

         bin = bin + 1

      END DO

      UPSILON(j,i) = C(bin)*T**alpha(bin)

   END IF

END DO

100 close(10)

RETURN
END
      

   
