PROGRAM READER_SI

INTEGER :: i, n, k, l, u
CHARACTER :: trash
CHARACTER(len=21), DIMENSION(100) :: config
DOUBLE PRECISION, DIMENSION(100) :: level, J, alpha, alpha_T0
character(len=21) :: temp
DOUBLE PRECISION, DIMENSION(1000) :: wl, A, Elow, Ehigh
DOUBLE PRECISION, DIMENSION(100,100) :: UPSILON, UPSILON_T

alpha = 0
aplha_T0 = 0
UPSILON = 0
UPSILON_T = 0

! ....................................................

OPEN(10, file='sI_NIST.dat'); REWIND(10)

DO i = 1, 3
   READ(10,*) trash
END DO

i = 0
DO WHILE (1==1)

   READ(10,'(A21)',END=100, advance='no') config(i+1)

   i = i + 1

   temp = config(i)
   PRINT *, temp

   IF (temp(1:1) .NE. ' ') THEN

      READ(10,'(F7.0, F13.3)',END=100) J(i), level(i)
      PRINT *, 'New'
   

   ELSE

      READ(10,'(F7.0, F13.3)',END=100) J(i), level(i)
  
      config(i) = config(i-1)
     

   END IF


END DO

100 continue

PRINT *, 'no lines:', i

close(10)

OPEN(20, file='sI.dat', STATUS='REPLACE')

WRITE(20,*) 'SI  NIST DATA'
WRITE(20,*) 'n       E        g'

DO k = 1, i

   WRITE(20,'(I5, F15.3, I7, A30)') k, level(k), INT(2*J(k)+1), config(k)

END DO

! ----------- LINE READING --------------------------------------

OPEN(30, file='sI_lines.dat');REWIND(30)

DO k = 1, 5
   READ(30,*) trash
END DO

n = 1
DO WHILE (1==1)

   READ(30,*,END=200) wl(n), trash, A(n), trash, trash, trash, Elow(n), trash, Ehigh(n)

   IF (n>2) THEN
      IF (wl(n) .EQ. wl(n-1)) THEN
         WRITE(*,*) 'SAME WL!', n
         STOP 1
      END IF
   END IF

   n = n + 1

END DO

200 continue

close(30)

! --------------- WRITE LINES ---------------------------------------


WRITE(20,*) 'Lines'
WRITE(20,*) 'i   j    WL      A'

DO u = 2, i
   DO l = 1, u-1

      DO k = 1, n

         IF ( (Ehigh(k) .EQ. level(u)) .AND. (Elow(k) .EQ. level(l) ) )THEN

               WRITE(20,'(2I5, F20.2, ES12.2, ES10.2)') u, l, wl(k), A(k), UPSILON(u,l)

         END IF

      END DO

   END DO

END DO


close(20)

END
