PROGRAM READER_SiII
IMPLICIT NONE

INTEGER :: i, n, k, l, u, nn
CHARACTER :: trash
CHARACTER(len=23), DIMENSION(50) :: config
CHARACTER(len=4), DIMENSION(50) :: term
DOUBLE PRECISION, DIMENSION(50) :: level, J, alpha, alpha_T0
character(len=15) :: temp
DOUBLE PRECISION, DIMENSION(1000) :: wl, A, Elow, Ehigh
DOUBLE PRECISION, DIMENSION(100,100) :: UPSILON, T0
INTEGER :: J1, J2

alpha = 0
alpha_T0 = 0
UPSILON = 0
T0 = 0

! ....................................................

OPEN(10, file='siII_NIST.dat'); REWIND(10)

DO i = 1, 3
   READ(10,*) trash
END DO

i = 0
DO WHILE (1==1)

   READ(10,'(A23)',END=100, advance='no') config(i+1)

   i = i + 1

   temp = config(i)

   PRINT *, temp

   IF (temp(1:1) .NE. ' ') THEN

      READ(10,'(A4,I5,A1,I1,F15.2)',END=100) term(i), J1, trash, J2, level(i)
      J(i) = DBLE(J1)/DBLE(J2)
      PRINT *, term(i), J(i), level(i)

   ELSE

      READ(10,'(A8,I1,A1,I1,F15.2)',END=100) trash, J1, trash, J2, level(i)
      J(i) = DBLE(J1)/DBLE(J2)
      PRINT *, term(i), J(i), level(i)

      config(i) = config(i-1)
      term(i) = term(i-1)

   END IF


END DO

100 continue

PRINT *, 'no lines:', i

close(10)

OPEN(20, file='siII.dat', STATUS='REPLACE')

WRITE(20,*) 'Si II'
WRITE(20,*) 'n       E        g'

DO k = 1, i

   WRITE(20,'(I5, F15.3, I7, A25, A4)') k, level(k), INT(2*J(k)+1), config(k), term(k)(1:4)

END DO



! ----------- LINE READING --------------------------------------

OPEN(30, file='siII_lines.dat');REWIND(30)

DO k = 1, 5
   READ(30,*) trash
END DO

n = 1
DO WHILE (1==1)

   READ(30,*,END=200) wl(n), trash, A(n), trash, trash, trash, Elow(n), trash, Ehigh(n)

   n = n + 1

END DO

200 continue

close(30)

OPEN(40,file='siII_collisions.dat',STATUS='oLD')

READ(40,*) trash

DO nn = 1, 10

   READ(40,*) u, l, UPSILON(u,l), T0(u,l)

END DO

close(40)

! --------------- WRITE LINES ---------------------------------------

WRITE(20,*) 'Lines'
WRITE(20,*) 'i   j    WL      A'

DO u = 2, i
   DO l = 1, u-1

      DO k = 1, n

         IF ( (Ehigh(k) .EQ. level(u)) .AND. (Elow(k) .EQ. level(l) ) ) THEN

               WRITE(20,'(2I5, F20.2, ES12.2, F10.2, I10, F10.2, I10)') u, l, wl(k), A(k), UPSILON(u,l), INT(T0(u,l))

         ELSE IF (UPSILON(u,l) .NE. 0) THEN

                WRITE(20,'(2I5, F20.2, ES12.2, F10.2, I10, F10.2, I10)') u, l, real(0), real(0), UPSILON(u,l), INT(T0(u,l))

                EXIT

         END IF

      END DO

   END DO

END DO


close(20)

END
