subroutine init_random_seed()
use m1, only : myid

! -----------------------------
! Task : resets the seed for computing random number
! ---------------------------

INTEGER :: i, n, clock
INTEGER, DIMENSION(:), ALLOCATABLE :: seed

CALL RANDOM_SEED(size = n)

ALLOCATE(seed(n))

CALL SYSTEM_CLOCK(COUNT=clock)

 seed = clock + 37 * (/ (i - 1, i = 1, n) /) + myid
!seed = 1597535 + 37 * (/ (i - 1, i = 1, n) /) + myid
CALL RANDOM_SEED(PUT = seed)

DEALLOCATE(seed)

END SUBROUTINE
